
#ifndef __keyd_actions_H
#define __keyd_actions_H

#include "keyd.h"

typedef struct mixer_action {
	int len;
	action_proc_t fn;
	int mixer;
	int op;
	int rec;
	int left;
	int right;
} *mixer_action_t;

#define NUM_MIXERS SOUND_MIXER_NRDEVICES
#define MIX_RECONLY 0
#define MIX_SET 1
#define MIX_DELTA 2
#define MIX_MUTE 3

typedef struct cd_action {
	int len;
	action_proc_t fn;
	int op;
	int from, to;
	char device[1];
} *cd_action_t;

#define CD_PLAY 1
#define CD_STOP 2
#define CD_PAUSE 3
#define CD_NEXT 4
#define CD_PREV 5
#define CD_EJECT 6
#define CD_STOPEJECT 7
#define CD_LOCK 8
#define CD_UNLOCK 9

typedef struct console_action {
	int len;
	action_proc_t fn;
	int op;
	int con;
	int mark;
} *console_action_t;

#define CON_NEW 1
#define CON_SWITCH 2
#define CON_MARK 3
#define CON_REST 4
#define CON_NEXT 5
#define CON_PREV 6
#define CON_MAX_MARKS 32

typedef struct multi_action {
	int len;
	action_proc_t fn;
	action_t first;
	action_t next;
} *multi_action_t;

typedef struct exec_action {
	int len;
	action_proc_t fn;
	int uid;
	int gid;
	char cmd[1];
} *exec_action_t;


/************ Constructor functions **************/

action_t makeNullAction( );
action_t makeModeAction( char * );
action_t makeExecAction( int, int, char * );
action_t makeMixerAction( int, char *, int, int, int );
action_t makeCDAction( char *, int, int, int );
action_t makeConsoleAction( int, int, int );
action_t makeMultiAction( action_t, action_t );

#endif /* !__keyd_actions_H */
