#include <sys/ioctl.h>
#include <linux/vt.h>
#include "keyd.h"
#include "actions.h"


#define switchVT(x) ioctl( consolefd, VT_ACTIVATE, x )

int _console_marks[CON_MAX_MARKS];

void doConsoleAction( console_action_t con )
{
	struct vt_stat stat;
	int cur;
	
	if( ioctl( consolefd, VT_GETSTATE, &stat )){
		log( LOG_ERR, "Ioctl VT_GETSTATE failed!");
		return;
	}
	cur = stat.v_active;
	
	switch(con->op) {
		case CON_NEW:
			break;
		case CON_SWITCH:
			switchVT( con->con );
			break;
		case CON_MARK:
			_console_marks[con->mark] = cur;
			break;
		case CON_REST:
			if( _console_marks[con->mark]>0 )
				switchVT( _console_marks[con->mark] );
			break;
	}
}

